package com.bigflix.BigFlixMovies;

import android.app.Activity;
import android.os.Bundle;
import android.view.View;
import android.view.View.OnClickListener;
import android.view.Window;
import android.widget.CheckBox;
import android.widget.CompoundButton;
import android.widget.EditText;
import android.widget.TextView;
import android.widget.Toast;
import com.app.pokktsdk.PokktConfig;
import com.app.pokktsdk.PokktManager;
import com.app.pokktsdk.enums.AnalyticsType;
import com.app.pokktsdk.enums.PokktIntegrationType;
import com.app.pokktsdk.util.AndroidDeviceInfo;
import com.pokkt.videodemo.R;

public class OfferwallActivity extends Activity {
    EditText edt_points;
    CheckBox chbox_close_success;
    PokktConfig pokktConfig = new PokktConfig();

    @Override
    protected void onCreate(Bundle savedInstanceState) {
        requestWindowFeature(Window.FEATURE_NO_TITLE);
        super.onCreate(savedInstanceState);

        setContentView(R.layout.offerwall);

        if (!AndroidDeviceInfo.isNetworkAvailable(this)) {
            Toast.makeText(this, "Network Not Available!! Please Connect to Internet First.", Toast.LENGTH_LONG).show();
            finish();
        }

        OfferwallDelegate.offerwallActivity = this;

        // set the requisite parameters
        pokktConfig.setSecurityKey("iJ02lJss0M");
        pokktConfig.setApplicationId("a2717a45b835b5e9f50284a38d62a74e");
        pokktConfig.setIntegrationType(PokktIntegrationType.INTEGRATION_TYPE_ALL);
        // to disable video caching
        pokktConfig.setAutoCacheVideo(false);
        pokktConfig.setOfferWallAssetValue("");
        pokktConfig.setCloseOnSuccessFlag(false);
        // this will be a unique id per user from developer side
        // developer is free to choose any String data point.
        pokktConfig.setThirdPartyUserId("123456");

        // GOOGLE ANALYTICS
        pokktConfig.setSelectedAnalyticsType(AnalyticsType.GOOGLE_ANALYTICS);
        pokktConfig.setGoogleAnalyticsID("UA-64853553-2");

//        //FLURRY
//        pokktConfig.setSelectedAnalyticsType(AnalyticsType.FLURRY);
//        pokktConfig.setFlurryApplicationKey("W8XX8KPBS497Y8J6JYTT");
//
//        //MIXPANEL
//        pokktConfig.setSelectedAnalyticsType(AnalyticsType.MIXPANEL);
//        pokktConfig.setMixPanelProjectToken("927688624ac5894332babbe763c23aa4");

        PokktManager.setDebug(true);
        PokktManager.initPokkt(this, pokktConfig);

        edt_points = (EditText) findViewById(R.id.edt_max_points);
        chbox_close_success = (CheckBox) findViewById(R.id.chk_close_on_success);

        chbox_close_success.setOnCheckedChangeListener(new CompoundButton.OnCheckedChangeListener() {
            @Override
            public void onCheckedChanged(CompoundButton buttonView, boolean isChecked) {
                pokktConfig.setCloseOnSuccessFlag(isChecked);
            }
        });

        edt_points.setOnClickListener(new OnClickListener() {

            @Override
            public void onClick(View v) {
                edt_points.setFocusable(true);
                edt_points.setFocusableInTouchMode(true);
            }
        });

        findViewById(R.id.button).setOnClickListener(new OnClickListener() {
            @Override
            public void onClick(View v) {
                PokktManager.getCoins(OfferwallActivity.this, pokktConfig);

            }
        });

        findViewById(R.id.button_incomplete).setOnClickListener(new OnClickListener() {
            @Override
            public void onClick(View v) {
                PokktManager.getPendingCoins(OfferwallActivity.this, pokktConfig);
            }
        });

        findViewById(R.id.button_max).setOnClickListener(new OnClickListener() {

            @Override
            public void onClick(View v) {
                String temp = edt_points.getText().toString();
                try {
                    if (!"".equals(temp)) {
                        pokktConfig.setOfferWallAssetValue(temp);
                        PokktManager.getCoins(OfferwallActivity.this, pokktConfig);
                    } else
                        Toast.makeText(OfferwallActivity.this, "Please enter points", Toast.LENGTH_LONG).show();
                } catch (Exception e) {
                    Toast.makeText(OfferwallActivity.this, "Please enter valid points", Toast.LENGTH_LONG).show();
                }
            }
        });

        updateUI(Storage.getOfferWallPoints(this));
    }

    void updateUI(int points) {
        ((TextView) findViewById(R.id.points)).setText("Points earned: " + points);
    }

    protected void onResume() {
        super.onResume();
        PokktManager.checkCampaignAvailable(this, pokktConfig);
        PokktManager.getPendingCoins(this, pokktConfig);
    }
}
