package com.bigflix.BigFlixMovies;

import android.app.Activity;
import android.content.res.Configuration;
import android.os.Bundle;
import android.view.View;
import android.view.View.OnClickListener;
import android.view.Window;
import android.widget.Button;
import android.widget.TextView;
import android.widget.Toast;
import com.app.pokktsdk.PokktConfig;
import com.app.pokktsdk.PokktManager;
import com.app.pokktsdk.enums.PokktIntegrationType;
import com.app.pokktsdk.util.AndroidDeviceInfo;
import com.pokkt.videodemo.R;

public class VideoActivity extends Activity {
	private Button _btnPlayVideoWithIncent;
	private Button _btnPlayVideoWithoutIncent;
	PokktConfig pokktConfig = new PokktConfig();

	@Override
	protected void onCreate(Bundle savedInstanceState) {
		requestWindowFeature(Window.FEATURE_NO_TITLE);
		super.onCreate(savedInstanceState);

		setContentView(R.layout.video);

		if(!AndroidDeviceInfo.isNetworkAvailable(this)){
			Toast.makeText(this, "Network Not Available!! Please Connect to Internet First.", Toast.LENGTH_LONG).show();
			finish();
		}

		VideoDelegate.videoActivity = this;

		// set the requisite parameters
		pokktConfig.setSecurityKey("iJ02lJss0M");
		pokktConfig.setApplicationId("a2717a45b835b5e9f50284a38d62a74e");
		pokktConfig.setIntegrationType(PokktIntegrationType.INTEGRATION_TYPE_ALL);
		pokktConfig.setAutoCacheVideo(getIntent().getBooleanExtra("auto_caching", false));
		pokktConfig.setSkipEnabled(true);
		pokktConfig.setDefaultSkipTime(10);
		pokktConfig.setIncentivised(true);
		pokktConfig.setScreenName("Pokkt Sample Screen");
        pokktConfig.setBackButtonDisabled(true);
		// this will be a unique id per user from developer side
		// developer is free to choose any String data point.
		pokktConfig.setThirdPartyUserId("123456");

		PokktManager.setDebug(true);
		PokktManager.initPokkt(this, pokktConfig);

		Button _btnStartVideoCaching = (Button) findViewById(R.id.button_start_cache);
		_btnPlayVideoWithIncent = (Button) findViewById(R.id.button_video);
		_btnPlayVideoWithoutIncent = (Button) findViewById(R.id.button_video_non_incent);

		_btnStartVideoCaching.setOnClickListener(new OnClickListener() {
			@Override
			public void onClick(View v) {
				checkVideoCache();
			}
		});

		// hide start caching button in case of auto-caching is disabled
		if (pokktConfig.isAutoCacheVideo()) {
			_btnStartVideoCaching.setVisibility(View.INVISIBLE);
		}

		_btnPlayVideoWithIncent.setOnClickListener(new OnClickListener() {
			@Override
			public void onClick(View v) {
				pokktConfig.setIncentivised(true);
				PokktManager.playVideoCampaign(VideoActivity.this, pokktConfig);
				finish();
			}
		});

		_btnPlayVideoWithoutIncent.setOnClickListener(new OnClickListener() {
			@Override
			public void onClick(View v) {
				pokktConfig.setIncentivised(false);
				PokktManager.playVideoCampaign(VideoActivity.this, pokktConfig);
				finish();
			}
		});

		if (PokktManager.isVideoAvailable()) {
			showButtons();
		}

		updateUI(Storage.getVideoPoints(this));
	}

	@Override
	protected void onResume() {
		super.onResume();

		if (!PokktManager.isVideoAvailable()) {
			hideButtons();
		}
	}

	@Override
	protected void onDestroy() {
		super.onDestroy();
	}

	protected void checkVideoCache(){
		if (!PokktManager.isVideoAvailable()) {
			PokktManager.cacheVideoCampaign(VideoActivity.this, pokktConfig);
		}else{
			Toast.makeText(VideoActivity.this, "Video ia already Available", Toast.LENGTH_LONG).show();
			showButtons();
		}
	}

	void updateUI(float points) {
		((TextView) findViewById(R.id.points)).setText("Points earned: " + points);
	}

	void showButtons() {
		_btnPlayVideoWithIncent.setText("Play Incent Vdo To Earn " + PokktManager.getVideoVc(this));
		_btnPlayVideoWithIncent.setVisibility(View.VISIBLE);
		_btnPlayVideoWithoutIncent.setVisibility(View.VISIBLE);
	}

	private void hideButtons() {
		_btnPlayVideoWithIncent.setVisibility(View.GONE);
		_btnPlayVideoWithoutIncent.setVisibility(View.GONE);
	}

	public void updatePoints(float points) {
		if (points == -1.00F) {
            // no points to be given.
		} else {
			updateUI(Storage.getVideoPoints(this));
		}
	}

	@Override
	public void onConfigurationChanged(Configuration newConfig) {
		super.onConfigurationChanged(newConfig);
	}
}
